"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class LocalContext {
    constructor(binding) {
        this.m_Binding = binding;
    }
    get m_Path() {
        return this.m_Binding.path;
    }
    get m_Code() {
        return this.m_Path.node;
    }
    get m_Refs() {
        return this.m_Binding.referencePaths;
    }
    get m_Name() {
        return this.m_Code.id.name;
    }
    Resolve(dsl) {
        this.m_Code.body.directives = [];
        this.m_Code.body.body = dsl.Transcribe(this.ToStatements(), this.m_Path);
    }
    ToStatements() {
        return this.m_Code.body.body;
    }
    GetDSLName() {
        const [directive] = this.m_Code.body.directives;
        if (directive) {
            const [use, dsl_name] = directive.value.value.split(" ");
            return dsl_name;
        }
        return "";
    }
}
exports.LocalContext = LocalContext;
