"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class MethodCode {
    constructor(path) {
        this.m_Path = path;
    }
    get m_Code() {
        return this.m_Path.node;
    }
    get m_Left() {
        return this.m_Expression.left;
    }
    get m_Right() {
        return this.m_Expression.right;
    }
    get m_Expression() {
        return this.m_Code.expression;
    }
    get m_ClassName() {
        return this.m_Left.openingElement.name.name;
    }
    ToClassMethod() {
        const { id, params: raw_params, body, typeParameters } = this.m_Right;
        const params = raw_params.filter(param => {
            if (types_1.isIdentifier(param) && param.name === "this") {
                return false;
            }
            return true;
        });
        const kind = id.name === "constructor" ? id.name : "method";
        const class_method = types_1.classMethod(kind, id, params, body);
        class_method.typeParameters = typeParameters;
        return class_method;
    }
}
exports.MethodCode = MethodCode;
const types_1 = require("@babel/types");
