"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Transcriber {
    constructor(_module) {
        this.m_Module = new module_1.ModuleCode(_module);
        this.m_ClassMap = new Map();
        this.m_MethodMap = new Map();
        this.m_ContextMap = new Map();
        this.m_InlineContextMap = new Map();
        this.m_DSLMap = new Map();
        this.m_Plugins = new Array();
    }
    Transcribe() {
        this.m_Plugins.forEach(plugin => plugin.Transcribe());
        return utility_1.ToString(this.m_Module.m_File, {
            comments: false
        });
    }
    AddDSL(name, dsl) {
        this.m_DSLMap.set(name, dsl);
    }
    GetDSL(name) {
        return this.m_DSLMap.get(name);
    }
    GetLocalContext(name) {
        return this.m_ContextMap.get(name);
    }
    TraverseLocalContext(callback) {
        this.m_ContextMap.forEach((context, name) => callback(context, name));
    }
    TraverseInlineContext(callback) {
        this.m_InlineContextMap.forEach(context => callback(context));
    }
    GetClass(name) {
        return this.m_ClassMap.get(name);
    }
    TraverseMethod(callback) {
        this.m_MethodMap.forEach((methods, class_name) => callback(methods, class_name));
    }
}
exports.Transcriber = Transcriber;
const utility_1 = require("../common/utility");
const module_1 = require("../code-object/module");
